/*********************************************************************
 *
 *     Fichero principal del proyecto del simulador de la tarjeta
 *		Advantech.
 *
 *********************************************************************
 * FileName:        Main.c
 *
 * Author  Alejandro Daniel Pez Espinosa     
 ********************************************************************/
 
#include "main.h"
#include <string.h>
#include <stdlibm.h>
#include <stdlib.h> 
#include "trama.c"
#include "funciones.c"
#include "TramaEthernet.c"
#include "muestreo.c"

void main()
{
	int1 flag_select=TRUE;
	CounterReset();
	ConfigPic();
	ConfigPuertas();
	enable_interrupts(GLOBAL);  	// Activamos de las interrupciones 
	enable_interrupts(INT_TIMER1);	 
	enable_interrupts(INT_RDA);		// Activacin temporal del acceso al puerto Serie para la configuracin del modo
	th_in=5;			// Por defecto el valor del umbral lo establecemos en 5, ya el resto ser mediante la API.
	//Codigos  tr
    
/***	Seleccion de modo funcionamiento	***/
	
	ON(PIN_J3);
	while( flag_select )
	{
		if( recibo ){
			flag_select=SeleccionModo();
		}
		
	}
	//disable_interrupts(INT_RDA);	// Desactivacin del acceso puerto serie
			
/**** Fin modo de seleccion ***/
	
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_2);	
		
	OFF(PIN_J3);	
	 			         
// Bucle principal del programa

	while( TRUE )       
	{ 	
		if( flag_red )
		{		
			// Funcin necesaria para el funcionamiento de red.
			StackTask(); 
		}	
		if( STATUS == STAND_BYE )
		{	
			/* Se hace un doble if, porque sino los LEDS no se mantienen visibles al ojo */
			ON(PIN_J0);
			OFF(PIN_J1);
			OFF(PIN_J2);
			if( STATUS == STAND_BYE )
			{
				
				while( wait )
                {
					status_muestreo();
				}
				while( enable_listen )
				{
					RecibirMensajeUDP();
				}
				if( recibo )
				{
					status_recibo();
				}
                      /* el resto del proceso lo lleva la funcin timer_muestreo */	
   			}                    								
			
		}
		else if( STATUS == POLLING )
		{
            OFF(PIN_J0);
            ON(PIN_J1);
            OFF(PIN_J2);		
			if( STATUS == POLLING ){
				while( wait )
                 {
                    status_muestreo();
                }
				while( enable_listen )
				{
					RecibirMensajeUDP();
				}
				if( proceso )
				{
					status_proceso();
				}
				if( recibo )
				{
					status_recibo();	
				}
				else
				{
					proceso=TRUE;
				}
			}                    
		}
		else if( STATUS == EVENT )
		{
            OFF(PIN_J0);
            OFF(PIN_J1);
            ON(PIN_J2);
			if( STATUS == EVENT ){
				while( wait )
				{
					status_muestreo();
				}
                while( enable_listen )
                {
                    RecibirMensajeUDP();
                }
                if( toggle )
                {
                    status_toggle();
				}
                if( proceso )
                {
                    status_proceso();
                }
                if( recibo )
                {
					status_recibo();
                }
                else
               	{
                    proceso=TRUE;
                }
   			}                    
	    }
	}      
} 
/* 
Funcin que lleva a cabo al desbordar el timer0. Segun el modo de funcionamiento realizara una funcin u otra.
Si el modo de funcionamiento es en modo puerto serie, se encargara de desactivar la escucha del puerto serie 
aproximadamente cada 500ms.
Si el modo de funcionamiento es en modo red, este es encargado de temporizar los tickets para el funcionamiento 
de la red. El cdigo ha sido sacado de la libreria tick.c del fabricante Microchip.
Tambin donde se incrementa el contador de keep alive, si este estuviera activo.
*/
#int_TIMER0
void timer_escucha_RS232(void)
{
 	//output_toggle(PIN_J7);
	if( flag_serie )
	{	
		set_timer0(2812);
		disable_interrupts(INT_RDA);
		disable_interrupts(INT_TIMER0);
		if( cont_serie==2 )
		{
			cont_serie=0;
		}	
		cont_serie++;
	}
		
	if( !recibo )
	{
		 enable_interrupts(INT_TIMER1);
	}		 
	
    wait=FALSE;
    
	
	if( flag_red )
	{
		/* Codigo sacado del archivo tick.c para la emplementacion de las temporizaciones de 
		red */
		
		TickCount++;    //increment this every 100ms
		
		second_counter_intermediate++;
		if (second_counter_intermediate >= TICKS_PER_SECOND)
		{
			second_counter++; //increment this ever 1s
			second_counter_intermediate=0;
		}
		set_timer0(TICK_COUNTER); //set timer0 to properly interrupt every 100ms
		if( cont_red==5 )
		{	    	
			enable_listen=FALSE;	
			cont_red=0;
		}
    		
		cont_red++;	
	}

	if( keepalive )
	{
		/*
		Realizamos esta comprobacin de si el contador de red fuera 5 ya que en este modo, el desbordamiento del temporizador 
		se realiza cada 100ms, necesario para el funcionamiento.
		*/
		if( cont_red == 10 && flag_red )  
		{
	    
	            count_keepalive++;
	            /* Sumamos siempre 1 al contador de keep_alive y ya en la funcin
	            *  proceso_Rx nosotros jugamos con el numero de veces que se quiera
	            *  que se repita. Este timer se desborda cada 500ms aproximadamente, y por 
	            *  lo tanto jugamos cada cuanto queremos que se envie el keep_alive */
	    	}
    	else if( flag_serie && cont_serie == 2)
		{
			count_keepalive++;
		}		
	}    
}	
/*
Funcin que realizara al ser desbordado el timer1. Esta funcin se encarga de temporizar el muestreo, o sea, que cada 10,4 ms, 20,9 ms, 
41,9ms o 83,8ms, segn se establezca desde la API. 
*/
#int_TIMER1
void timer_muestreo(void)
{	
	set_timer1(0);	
	//disable_interrupts(INT_TIMER1);
	enable_interrupts(INT_TIMER0);
	if( flag_serie )
	{
		enable_interrupts(INT_RDA);
			
	}
	else if( flag_red )
    {
        enable_listen=TRUE;
    }
	wait=TRUE;		
}

/*
Funcin en cargada al salta la interrupcin por recepcin en el puerto Rs232 establecida en el PIN C7
*/
#int_RDA
void recepcion_RS232(void) 
{  
	unsigned char c, temp[LONG_TRAMA];
	int i=0;
	int1 error=FALSE;
	long time_out=0;
	disable_interrupts(GLOBAL); 
	disable_interrupts(INT_RDA);
	//disable_interrupts(INT_TIMER0);	
	do
	{	    		
    	if( kbhit() )
		{   
			c=getc();
			temp[i]=c;
			i++;
			time_out=0;
		}
//		else time_out++;	 
//		if( time_out>1000) {
//			error=TRUE;
//			break;
//		}	
	}while( i<LONG_TRAMA-2 );
	if(!error)
	{	
		recibo=TRUE;   
		memcpy(rx_trama , temp , LONG_TRAMA);
	}	
}


/*	Se realiza el proceso de llamada al muestreo y posteriormente copia de los cambios realizados en el arras s_old_in.	*/
void status_muestreo()
{
        int i=0;
        muestreo(th_in);
        for( i=0 ; i<NUM_PUERTAS ; i++ )
        {
                s_old_in[i]=s_new_in[i];
        }
        enable_interrupts(INT_TIMER1);
}

/*	Donde se lleva a cabo el proceso de KeepAlive	*/
void status_proceso()
{
        disable_interrupts(INT_TIMER1);
        ProcesoRx();
        proceso=FALSE;
        enable_interrupts(INT_TIMER1);
}

/*	Donde se lleva a cabo las tareas si se ha recibo informacin por parte del PC	*/
void status_recibo()
{
        disable_interrupts(INT_TIMER1);
        mirar_trama();
        recibo=FALSE;
        enable_interrupts(GLOBAL);
        enable_interrupts(INT_TIMER1);
        if( STATUS != STAND_BYE )
        {
            proceso=TRUE;
        }
}

/*	Se se comprueba que se produce un cambio en las puertas se hace el envo de informacin al PC	*/
void status_toggle()
{
        disable_interrupts(INT_TIMER1);
        enviar( SEND_IN , 1 );
        toggle=FALSE;
        wait=TRUE;
        enable_interrupts(INT_TIMER1);
}

