/*********************************************************************
 *
 *     Fichero encargado del muestreo como del escaneo de todas
 *	   las puerta logicas especificas del PIC 
 *
 *********************************************************************
 * FileName:        Muestreo.c
 *
 * Author  Alejandro Daniel Pez Espinosa     
 ********************************************************************/
 
#include "muestreo.h"

void muestreo(int th_in)
{
	int i=0;
	int1 flag=TRUE;
	toggle=FALSE;

	/* Actualizamos muestreo, en donde observamos todas las puertas */
	update_muestreo();
	
	for( i=0 ; i<NUM_PUERTAS ; i++)
	{		
		if(s_new_in[i] != s_old_in[i] ) //c_in[i]=0; // No ha habido cambio
		{
			c_in[i]++;
			flag=FALSE;
		}		
	}
		
	if( !flag )
	{
		for( i=0 ; i<NUM_PUERTAS ; i++)
		{
			if( c_in[i] >= th_in )  // Si estamos aqui es que ha habido cambio
			{
				flag=TRUE;
				toggle=TRUE;
				c_in[i]=0;
				wait=FALSE;
				disable_interrupts(INT_TIMER1);
				break;	// Salimos de el for
			}	
		}
	}
}	
		
void update_muestreo()
{
	int8 i;
	
	for(i=0;i<8;i++){
		s_new_in[i]=bit_test(PORTA,i);		
		s_new_in[i+8]=bit_test(PORTB,i);		
		s_new_in[i+24]=bit_test(PORTE,i);		
		s_new_in[i+32]=bit_test(PORTF,i);
		s_new_in[i+40]=bit_test(PORTG,i);		
		s_new_in[i+48]=bit_test(PORTH,i);
		s_new_in[i+56]=bit_test(PORTJ,i);
	}	
	
	/* Estos son los PINES sobrantes ya que el resto se ha utilizado para la configuracin
	 * de puerto serie y ethernet */
	s_new_in[16]=bit_test(PORTC,0);
	s_new_in[17]=bit_test(PORTC,1);
	s_new_in[18]=bit_test(PORTC,2);
	s_new_in[19]=bit_test(PORTD,1);
	s_new_in[20]=bit_test(PORTD,5);
	s_new_in[21]=bit_test(PORTD,6);
	s_new_in[22]=bit_test(PORTD,7);
}	

	